image: python:3.6

services:
  - postgres:9.6

variables:
  POSTGRES_USER: postgres
  POSTGRES_PASSWORD: password
  POSTGRES_DB: smi-slave-test
  POSTGRES_PORT: 5432
  POSTGRES_HOST: postgres
  IMAGE_TAG: lappis/smi-slave
  SLAVE_SECRET_KEY: some-random-stuff
  ENVIRONMENT: test
  ALLOWED_HOSTS: "*"
  CONTRACTED_VOLTAGE: 220

stages:
  - test
  - build

before_script:
  - pip install -r requirements.txt
  - python3 manage.py makemigrations
  - python3 manage.py migrate

docker:
  stage: test
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - docker --version
  script:
    - docker build -t smi-slave .

test:
  stage: test
  script:
    - python manage.py test --verbosity=3

stylesheet:
  stage: test
  script:
    - pycodestyle .

code_quality:
  stage: test
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  before_script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
  script:
    - docker run
        --env SOURCE_CODE="$PWD"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock
        "registry.gitlab.com/gitlab-org/security-products/codequality:$SP_VERSION" /code
  artifacts:
    paths:
      - gl-code-quality-report.json
    reports:
      codequality: gl-code-quality-report.json
  only:
    - master

homolog:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  only:
    - tags
